#ifndef _CARD_HEADER
#define _CARD_HEADER
enum suit{HEART=3, DIAMOND=4, CLUB=5, SPADE=6};
enum rank{ACE=1, TWO, THREE, FOUR, FIVE, SIX, SEVEN,
	EIGHT, NINE, TEN, JACK, QUEEN, KING};
enum tag{FACE_UP, FACE_DOWN};

struct card{
	enum suit s;
	enum rank r;
	enum tag t;
	struct card* next;
	struct card* prev;
};

struct card *generate_deck(void);
void card_to_string(struct card* card, char *string);
void print_card(struct card* card);
void print_deck(struct card* deck);
void print_deck_backwards(struct card* deck);
int get_length_of_deck(struct card* deck);
int get_color(struct card* card);
struct card *shuffle_deck(struct card* original);
int check_deck(struct card* deck);
struct card *find_card(struct card* card, struct card* deck);
#endif
