#include"console.h"

void set_output_color(enum color c)
{
	HANDLE out;

	out = GetStdHandle(STD_OUTPUT_HANDLE);

	SetConsoleTextAttribute(out, c);

}

// Insert colored text at current position of cursor
void print_text(char *s, int c)
{
	HANDLE out;
	DWORD written;

	enum color cl;

	out = GetStdHandle(STD_OUTPUT_HANDLE);

	if(c==0){
		cl = RED;
	}
	else if(c==1){
		cl = BLACK;
	}
	else{
		cl = WHITE;
	}
	SetConsoleTextAttribute(out, cl);
//	printf("%s", s);
	WriteConsole(out, s, strlen(s), &written, NULL);
	cl = WHITE;
	SetConsoleTextAttribute(out, cl);

}

// Insert colored text at specified coordinates
void position_text(char *s, int c, int x, int y)
{
	HANDLE out;
	COORD pos;
	DWORD written;
	COORD one;
	CHAR_INFO ch;
	SMALL_RECT r;
	int i;

	enum color cl;

	pos.X = 0;
	pos.Y = 0;
	one.X = 1;
	one.Y = 1;

	out = GetStdHandle(STD_OUTPUT_HANDLE);

	if(c==0){
		cl = RED;
	}
	else if(c==1){
		cl = BLACK;
	}
	else{
		cl = WHITE;
	}


	//SetConsoleTextAttribute(out, cl);
	ch.Attributes = cl;
//	WriteConsoleOutputCharacter(out, string, strlen(string), pos, &written);
	for(i=0;i<strlen(s);i++){
		r.Left = x+i;
		r.Right = x+i+1;
		r.Top = y;
		r.Bottom = y+1;
		ch.Char.AsciiChar = s[i];
		WriteConsoleOutput(out, &ch, one, pos, &r);
//		printf("%d %d %d %d\n", r.Left, r.Right, r.Top, r.Bottom);
		//pos.X++;
	}
//	cl = WHITE;
//	SetConsoleTextAttribute(out, cl);
}

//Set the position of the cursor
void position_cursor(int x, int y)
{
	HANDLE out;
	COORD pos;

	pos.X = x;
	pos.Y = y;


	out = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleCursorPosition(out, pos);
}

enum input_token get_input(enum input_token prev)
{
	HANDLE in;
	DWORD num_events;
	DWORD r;
	INPUT_RECORD event;
	enum input_token t;
	static int x;
	static int y;

	in = GetStdHandle(STD_INPUT_HANDLE);
	SetConsoleMode(in, ENABLE_MOUSE_INPUT);
	WaitForSingleObject(in, INFINITE);
	GetNumberOfConsoleInputEvents(in, &num_events);
	while(num_events>0){
//		printf("%d events left\n", num_events);
		ReadConsoleInput(in, &event, 1, &r);
		if(r==0){
			printf("Error reading input event\n");
		}
		if(event.EventType==MOUSE_EVENT){
			if(event.Event.MouseEvent.dwEventFlags==MOUSE_WHEELED){
			if(((int)event.Event.MouseEvent.dwButtonState)<0){
				return(DRAW);
			}
			else{
				return(UNDRAW);
			}
			}
			if((event.Event.MouseEvent.dwEventFlags==0 ||
			   event.Event.MouseEvent.dwEventFlags==DOUBLE_CLICK)//&&
//			event.Event.MouseEvent.dwButtonState!=0){
			){
				//Ignore button release unless button was
				//pressed at a different location
				if(x == event.Event.MouseEvent.dwMousePosition.X
						&&
				y == event.Event.MouseEvent.dwMousePosition.Y
					&& 
				event.Event.MouseEvent.dwButtonState==0
				){
					return NOP;
				}
				x = event.Event.MouseEvent.dwMousePosition.X;
				y = event.Event.MouseEvent.dwMousePosition.Y;
				if(y>5){
					if(x/4<7){
						return COL1+x/4;
					}
					else{
						return DRAW;
					}
				}
				else if(y==0 && x<9){
						return DRAW;
				}
				else if(y<5 && x<4){
						return DECK;
				}
				else if(y<5 && x<4*7){
						return UP;
				}
				else{
					return DRAW;
				}
			}
		}
		if(event.EventType==KEY_EVENT){
			if(event.Event.KeyEvent.bKeyDown){
				t = event.Event.KeyEvent.uChar.AsciiChar;
				switch(t){
					case DECK:
					case UP:
					case COL1:
					case COL2:
					case COL3:
					case COL4:
					case COL5:
					case COL6:
					case COL7:
					case DRAW:
					case UNDRAW:
					case QUIT:
				return(t);
					default:
						break; // do nothing
//				printf("%d %c\n",event.Event.KeyEvent.uChar.AsciiChar,event.Event.KeyEvent.uChar.AsciiChar);  
				}
			}
		}
		num_events--;
	}
	return NOP;
}
