#include<stdio.h>
#include"klondike.h"
#include<windows.h>
//Deal a game using the deck that is supplied (assumed to be already shuffled)
//the function "destroys" the deck, in that the original list is broken up
//into 7 lists of columns and 1 list for the deck
struct klondike* deal(struct card* deck)
{
	struct klondike* k;
	struct card* tmp;
	struct card* tmp2;
	int i;
	int j;

	k=(struct klondike*) malloc(sizeof(struct klondike));

	tmp=deck;
	for(i=0;i<7;i++){
//		printf("col: %d\n", i);
		k->col[i]=tmp;
		tmp->t=FACE_UP;
		for(j=0;j<i;j++){
//			print_card(tmp);
			tmp=tmp->next;
		}
//		print_card(tmp);
//		printf("\n");
		tmp2=tmp->next;
		tmp->next=NULL;
		tmp=tmp2;
	//	print_deck(k->col[i]);
	}
	//print_deck(tmp);
	k->deck=tmp;
	k->drawn=NULL;
	for(i=0;i<4;i++){
		k->stack[i]=NULL;
	}
	return(k);
}

//Print out the columns arranged vertically
void print_cols(struct klondike* k)
{
	int length[7];
	int i;
	int j;
	int max_length;
	char card_string[4];
	char *s_ptr;
	char *string;
	struct card* tmp;
	int depth;

	// print header
	printf(" 1   2   3   4   5   6   7 \n");
	max_length=0;

	for(i=0;i<7;i++){
		length[i]=get_length_of_deck(k->col[i]);
		if(length[i]>max_length){
			max_length=length[i];
		}
	}
//	printf("max_length = %d\n", max_length);
	//Need about 30 characters for each row
	string = (char *) malloc(sizeof(char)*30*max_length);
	s_ptr = string;
	for(i=0;i<7;i++){
		tmp=k->col[i];
		for(j=length[i]-1;j>=0;j--){
		//	printf("card i: %d j: %d\n", i, j);
			card_to_string(tmp, card_string);
			memcpy(s_ptr+j*29+i*4, card_string, 3);
			position_text(card_string, get_color(tmp), i*4, j+6);
			//printf(" ");
			memcpy(s_ptr+j*29+i*4+3, " ", 1);
			tmp=tmp->next;
//			Sleep(1000);
		}
		for(j=length[i];j<max_length;j++){
		//	printf("blank i: %d j: %d\n", i, j);
			memcpy(s_ptr+j*29+i*4, "    ", 4);
			position_text("    ", -1, i*4, j+6);
//			Sleep(1000);
		}
	}
	for(i=0;i<max_length;i++){
		//printf("line: %d\n", i);
		memcpy(s_ptr+i*29+28, "\n", 1);
	}
	position_text("Enter move:", -1, 0, 6+max_length);
	position_cursor(0, 6+max_length+1);
	s_ptr[29*max_length]=0;
//	printf("%s", string);
	free(string);

}

// Print out deck, drawn card, and discard stacks
void print_top(struct klondike* k)
{
	struct card* tmp;
	struct card* tmp2;
	struct card* tmp3;

	int i;
	printf("%3d ", get_length_of_deck(k->deck));
	printf("    ");
	for(i=0;i<4;i++){
		print_card(k->stack[i]);
		printf(" ");
	}
	printf("\n");
	tmp = k->drawn;
	if(tmp!=NULL){
		tmp2=tmp->next;
	}
	if(tmp2!=NULL){
		tmp3=tmp2->next;
	}
	if(tmp3!=NULL){
		print_card(tmp3);
	} printf("\n");
	if(tmp2!=NULL){
		print_card(tmp2);
	} printf("\n");
	if(tmp!=NULL){
		print_card(tmp);
	} printf("\n");
	printf("\n");



}

// Draw three card from deck to drawn cards
void draw(struct klondike* k)
{
	struct card* tmp;
	struct card* tmp2;
	int i;
	if(k->deck==NULL){
		while(k->drawn!=NULL){
			tmp = k->deck;
			k->deck = k->drawn;
			k->drawn = k->drawn->next;
			k->deck->next=tmp;
			k->deck->t = FACE_DOWN;
		}
	}
	else{
	for(i=0;i<3 && k->deck!= NULL; i++){
		tmp = k->drawn;
		k->drawn = k->deck;
		k->deck = k->deck->next;
		k->drawn->next = tmp;
		k->drawn->t = FACE_UP;
	//	print_card(k->drawn);
	}
	}
}

// "Undraw" three card from drawn cards back to deck
void undraw(struct klondike* k)
{
	struct card* tmp;
	struct card* tmp2;
	int i;
	if(k->drawn==NULL){
		return; // Do nothing
//		while(k->drawn!=NULL){
//			tmp = k->deck;
//			k->deck = k->drawn;
//			k->drawn = k->drawn->next;
//			k->deck->next=tmp;
//			k->deck->t = FACE_DOWN;
//		}
	}
	else{
	for(i=0;i<3 && k->drawn!= NULL; i++){
		tmp = k->deck;
		k->deck = k->drawn;
		k->drawn = k->drawn->next;
		k->deck->next = tmp;
		k->deck->t = FACE_DOWN;
	//	print_card(k->drawn);
	}
	}
}
// Print out entire klondike hand
void print_klondike(struct klondike* k)
{
	system("cls");
	print_top(k);
	print_cols(k);
}

// Move the top card from a list of card up to discard stack
int list_to_stack(struct klondike*k, struct card** list)
{
	struct card* tmp;
	int i;
	if((*list)->r == ACE){
		for(i=0;i<4;i++){
			if(k->stack[i]==NULL){
				k->stack[i]=*list;
				*list=(*list)->next;
				k->stack[i]->next=NULL;
				if(*list!=NULL){
					(*list)->t=FACE_UP;
				}
				return(0);
			}
		}
	}
	for(i=0;i<4;i++){
		if(k->stack[i]==NULL){
			continue;
		}
		if((*list)->s == k->stack[i]->s &&
				(*list)->r == k->stack[i]->r+1){
			tmp = k->stack[i];
			k->stack[i]=*list;
			*list=(*list)->next;
			k->stack[i]->next=tmp;
			if(*list!=NULL){
				(*list)->t=FACE_UP;
			}
			return(0);
		}
	}

	printf("Invalid move can't remove ");
	print_card(*list);
	printf("\n");

	return -1;

}

// Move a card from column up to discard stack
int col_to_stack(struct klondike* k, int col)
{
	if(k->col[col]==NULL){
		printf("Invalid move, column %d empty\n", col);
		return -1;
	}
	return(list_to_stack(k, &(k->col[col])));
}

// Move a card from drawn deck up to discard stack
int deck_to_stack(struct klondike* k)
{
	if(k->drawn==NULL){
		printf("Invalid move, no cards drawn\n");
		return -1;
	}
	return(list_to_stack(k, &(k->drawn)));
}

// Move a card from drawn deck down to a column
int deck_to_col(struct klondike* k, int col)
{
	struct card* tmp;
	if(k->drawn==NULL){
		printf("Invalid move, no cards drawn\n");
		return -1;
	}
	if(k->drawn->r == KING && k->col[col]==NULL){
		tmp = k->col[col]; //NULL
		k->col[col] = k->drawn;
		k->drawn = k->drawn->next;
		k->col[col]->next = tmp;
		return 0;
	}
	else if(k->drawn->r == k->col[col]->r-1 &&
			get_color(k->drawn)!=get_color(k->col[col])){
		tmp = k->col[col];
		k->col[col] = k->drawn;
		k->drawn = k->drawn->next;
		k->col[col]->next = tmp;
		return 0;
	}
	else{
		printf("Invalid move can't move \n");
		print_card(k->drawn);
		printf(" onto ");
		print_card(k->col[col]);
		printf("\n");
		return -1;
	}
}

// Move a card down from dicard stack back to column
int stack_to_col(struct klondike* k, int stack, int col)
{
	return 0;
}

// Move a card or stack of card from one column to another
int col_to_col(struct klondike* k, int src, int dst)
{
	struct card* tmp;
	struct card* tmp2;
	if(k->col[src]==NULL){
		printf("Invalid move column %d empty\n", src+1);
		return(-1);
	}
	if(src==dst){
//		printf("Invalid move source and destination are equal: %d\n",
//				src);
//		return(-1);
		return(0);
	}
	tmp=k->col[src];
	while(tmp!=NULL && tmp->t != FACE_DOWN){
		if(((tmp->r==KING && k->col[dst]==NULL))
				||(k->col[dst]!=NULL
				&& tmp->r == k->col[dst]->r-1
				&& get_color(tmp)!=get_color(k->col[dst]))){
				//print_card(k->col[src]);
				tmp2=k->col[dst];
				k->col[dst]=k->col[src];
				k->col[src]=tmp->next;
				tmp->next=tmp2;
			if(k->col[src]!=NULL){
				k->col[src]->t=FACE_UP;
			}
			return 0;
		}
		tmp=tmp->next;
	}
	printf("Invalid move can't move from column %d to %d\n", src+1, dst+1);
	return -1;
}
